package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function3;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import java.util.List;
import net.minecraft.world.item.ItemStack;

public class OutputData {
  public static Codec<OutputData> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)ItemAdapter.CODEC.fieldOf("stack").forGetter(()), (App)Codec.intRange(0, 64).fieldOf("min_count").forGetter(()), (App)Codec.intRange(0, 64).fieldOf("max_count").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe.OutputData::new));
  }
  
  public static final Codec<List<OutputData>> LIST_CODEC = Codec.list(CODEC);
  
  ItemStack stack;
  
  int min;
  
  int max;
  
  OutputData(ItemStack stack, int min, int max) {
    this.stack = stack;
    this.min = min;
    this.max = max;
    Preconditions.checkArgument((max >= min));
    this.stack.m_41764_(1);
  }
  
  public ItemStack getStack() {
    return this.stack;
  }
  
  public int getMin() {
    return this.min;
  }
  
  public int getMax() {
    return this.max;
  }
}
